#include <bits/stdc++.h>

using namespace std;

typedef vector<int> vi;

int main()
{ ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
  int i, n, maxa, pos, k, brek, tmp;
  bool tf, bleh;
  cin>> n;
  vi veka(n);
  for(i=0; i<n; i++)cin>> veka[i];
  i=0; tf=true;
  while(tf)
  { i++; if(i==n)break;
    if(veka[i]>veka[i-1])tf=false;
  }
  if(tf)
  { if(n>10){tmp=veka[n-2]; veka[n-2]=veka[n-1]; veka[n-1]=tmp;}
    else{ vi ceka(10);
          for(k=0; k<n; k++)ceka[veka[k]]++;
          bleh=true;
          for(k=0; k<n; k++)if(ceka[veka[k]]>1)bleh=false;
          if(bleh){tmp=veka[n-2]; veka[n-2]=veka[n-1]; veka[n-1]=tmp;}
    }
  }
  else
  { maxa=veka[i]; pos=i; brek=i;
    for(i++; i<n; i++)
      if(veka[i]>=maxa){pos=i; maxa=veka[i];}
    for(i=0; i<brek; i++)
      if(veka[i]<maxa){tmp=veka[i]; veka[i]=veka[pos]; veka[pos]=tmp; break;}
  }
  for(i=0; i<n; i++)cout<< veka[i]<< ' ';
  
  return 0;
}